#!/bin/bash
#
# An example of very simple messaging on GNUnet AFS
#
# This script takes as its option the keyword the message is to be found 
# with and launches an editor to edit the message, before sending. The 
# recipients are supposed to monitor the previously agreed upon key.
#
#

EDITOR="vim"
INSERT="gnunet-insert -Vnx"
NICK="rosebud"

############################################3#########################

if [ ! $1 ] ; then
  echo "Usage: $0 KEYWORD"
  exit
fi

TMPFILE=`mktemp`
DATE=`date`

trap "rm -f $TMPFILE" 0 2 3 4 6 7 8 10 11 12 13 15

$EDITOR $TMPFILE

if [ -s $TMPFILE ] ; then
  $INSERT -D "from $NICK ($DATE)" -K $1 -f message.txt $TMPFILE 
else
  echo File $TMPFILE was empty, aborting...
fi

rm -f $TMPFILE

