/**
 * 
 */

/**
 * @file include/api_errorcodes.h
 * @brief Definitions for errorcodes that are used in core API to the DHT-module. 
 * @author Tomi Tukiainen
 * @version $Id: api_errorcodes.h,v 1.8 2004/05/09 16:38:49 ttukiain Exp $ 
 */

#ifndef DHT_API_ERRORCODES_H
#define DHT_API_ERRORCODES_H 1

/* ************* DHT-operation's errorcodes *********** */

/* #define OK 1 */ /* this definition comes from gnunet_util.h */

#define DHT_ERRORCODE_BASE 1000
#define DHT_ERRORCODES__OP_REQUEST_REJECTED  (DHT_ERRORCODE_BASE+1)

/* ************* API specific errorcodes *********** */

#define API_ERRORCODE_BASE 50
#define DHT_ERRORCODES__API_ERROR_UNKNOWN                          (API_ERRORCODE_BASE+1)
#define DHT_ERRORCODES__API_CS_PROTO_RECEIVER_THREAD_CREATE_FAILED (API_ERRORCODE_BASE+2)
#define DHT_ERRORCODES__API_CS_PROTO_WRITE_TO_SOCKET_FAILED        (API_ERRORCODE_BASE+3)
#define DHT_ERRORCODES__API_MEMORY_ALLOCATION_FAILED               (API_ERRORCODE_BASE+4)
#define DHT_ERRORCODES__API_NO_SUCH_ELEMENT                        (API_ERRORCODE_BASE+5)

/* ************* DHT Client-Server protocol errorcodes *********** */

#define CS_ERRORCODE_BASE 100
#define DHT_ERRORCODES__CS_PROTO_UNEXPECTED_MESSAGE_RECEIVED (CS_ERRORCODE_BASE+1)
#define DHT_ERRORCODES__CS_PROTO_ACK_TIMEOUT                 (CS_ERRORCODE_BASE+2)
#define DHT_ERRORCODES__CS_PROTO_RESULTS_TIMEOUT             (CS_ERRORCODE_BASE+3)
#define DHT_ERRORCODES__CS_PROTO_INVALID_RESULTS             (CS_ERRORCODE_BASE+4)
#define DHT_ERRORCODES__CS_PROTO_PAYLOAD_EXCEEDED            (CS_ERRORCODE_BASE+5)

/**************** Datalayer specific error codes ****************/

#define DL_ERRORCODE_BASE 150
#define DHT_ERRORCODES__DATALAYER_STORAGE_FULL           (DL_ERRORCODE_BASE+1)
#define DHT_ERRORCODES__DATALAYER_KEYSTORAGE_FULL        (DL_ERRORCODE_BASE+2)
#define DHT_ERRORCODES__TABLE_NOT_FOUND                  (DL_ERRORCODE_BASE+3)
#define DHT_ERRORCODES__EMPTY_RESULT                     (DL_ERRORCODE_BASE+4)
#define DHT_ERRORCODES__DUPLICATE_DATA_UNIT              (DL_ERRORCODE_BASE+5)
#define DHT_ERRORCODES__DUPLICATE_TABLE_ID               (DL_ERRORCODE_BASE+6)


#endif /* DHT_API_ERRORCODES_H */
