/*
      This file is part of GNUnet

      GNUnet is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published
      by the Free Software Foundation; either version 2, or (at your
      option) any later version.

      GNUnet is distributed in the hope that it will be useful, but
      WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
      General Public License for more details.

      You should have received a copy of the GNU General Public License
      along with GNUnet; see the file COPYING.  If not, write to the
      Free Software Foundation, Inc., 59 Temple Place - Suite 330,
      Boston, MA 02111-1307, USA.
 */

/**
 * @file module/api_constants.c
 * @brief DHT-module's core API's constants. 
 * @author Tomi Tukiainen
 * @version $Id: api_constants.h,v 1.8 2004/05/10 08:29:40 ttukiain Exp $ 
 */

/* sleeping time to be used when waiting for data to be received */
#define API_SLEEP_MILLIS 50 

/* sleeping time between receive thread polling for any operation waiting for data */
#define RECEIVE_THREAD_SLEEP_MILLIS 50

/* timeouts (ms) for different operations or suboperations */
#define API_INITIALIZE_RESULTS_TIMEOUT 2000

#define API_CREATE_ACK_TIMEOUT         1000
#define API_CREATE_RESULTS_TIMEOUT     4000

#define API_INSERT_ACK_TIMEOUT         1000
#define API_INSERT_RESULTS_TIMEOUT     4000

#define API_FETCH_ACK_TIMEOUT          1000
#define API_FETCH_RESULTS_TIMEOUT      9000

#define API_JOIN_ACK_TIMEOUT           1000
#define API_JOIN_RESULTS_TIMEOUT       9000

#define API_LEAVE_ACK_TIMEOUT           1000
#define API_LEAVE_RESULTS_TIMEOUT       4000

#define API_TABLES_ACK_TIMEOUT           1000
#define API_TABLES_RESULTS_TIMEOUT       9000

#define API_INSERTED_ACK_TIMEOUT         1000
#define API_INSERTED_RESULTS_TIMEOUT     4000

#define API_DROP_ACK_TIMEOUT             1000
#define API_DROP_RESULTS_TIMEOUT         4000

/* operation status numbering, we are only interested in waitfor-statuses */
#define OPERATION_STATUS_OTHER 0 
#define OPERATION_STATUS_WAITFOR_ACK 1
#define OPERATION_STATUS_WAITFOR_RESULTS 2
#define OPERATION_STATUS_WAITFOR_STATUS 3

