/*
      This file is part of GNUnet

      GNUnet is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published
      by the Free Software Foundation; either version 2, or (at your
      option) any later version.

      GNUnet is distributed in the hope that it will be useful, but
      WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
      General Public License for more details.

      You should have received a copy of the GNU General Public License
      along with GNUnet; see the file COPYING.  If not, write to the
      Free Software Foundation, Inc., 59 Temple Place - Suite 330,
      Boston, MA 02111-1307, USA.
 */
 
/**
 * @file module/client-server.h
 * @brief Implementation of the server for client applications of DHT.
 * @author Marko Rih
 * @version $Id: client-server.h,v 1.7 2004/05/04 15:58:07 szviitan Exp $ 
 */

#ifndef DHT_CLIENTSERVER_H
#define DHT_CLIENTSERVER_H 1

/**
 * Initialization of CS server handles and memory structures.
 * @param capi 
 * @return 
 */
int initClientServer(CoreAPIForApplication * capi);

/**
 * Unregisters handlers, cleans memory structures etc when this node exits.
 * @param capi 
 * @return 
 */
int doneClientServer(CoreAPIForApplication * capi);

#endif /* DHT_CLIENTSERVER_H */
