/**
 * This file provides a dummy implementation for the persistance 
 * of the localstorage of a DHT module. Implementation doesn't provide any 
 * functionality, it just gives a 
 * 
 * @file module/datalayer_persistance.h
 * @brief dummy implementation for the persistance of the localstorage in a DHT module.
 * @author Simo Viitanen
 * @version $Id: datalayer_persistance.c,v 1.5 2004/05/17 20:22:14 szviitan Exp $ 
 */
#include "datalayer.h"
#include "datalayer_persistance.h"
#include "dht_util.h"
#include <gnunet_util.h>

static DHT_TableDef * empty_tables = NULL;
static DHT_LocalStoreUnit * empty_units = NULL;

int persistentCreateTable(
      const DHT_TableId       * tableId, 
      const DHT_TableMetaData * metadata, 
      const DHT_TableConfig   * config) 
{
#if DEBUG_DHT_DATALAYER
  LOG(LOG_DEBUG,
    "DEBUG: datalayer_persistance::persistentCreateTable(tableId: %s)\n", 
    hash160ToString(tableId));
#endif
  /* TODO: create a new file ??? */
  return OK;
}

int persistentStore(
      const DHT_TableId * tableId, 
      DHT_LocalStoreUnit * unitToStore) 
{
#if DEBUG_DHT_DATALAYER
  HexName hexTableId;
  hash2hex(tableId, &hexTableId);
  HexName hexUnitHash;
  hash2hex(&unitToStore->hash, &hexUnitHash);
  LOG(LOG_DEBUG, 
      "DEBUG: datalayer_persistance::persistentStore(tableId: %s, hash: %s)",
      hexTableId.data, hexUnitHash.data);
#endif
  /* TODO: insert unit to a file ??? (or put on insertqueue) */
  return OK;
}

int persistentRemove(const DHT_TableId * tableId, 
        DHT_LocalStoreUnit * unitToRemove) 
{
#if DEBUG_DHT_DATALAYER
  HexName hexTableId;
  hash2hex(tableId, &hexTableId);
  HexName hexUnitHash;
  hash2hex(&unitToRemove->hash, &hexUnitHash);
  LOG(LOG_DEBUG, 
      "DEBUG: datalayer::persistentRemove(tableId: %s, hash: %s)",
      hexTableId.data, hexUnitHash.data);
#endif
  /* TODO: delete unit from a file ??? (or put on delete queue) */
  return OK;
}

DHT_LocalStoreUnit ** persistentListData(
      const DHT_TableId * tableId) 
{
#if DEBUG_DHT_DATALAYER
  LOG(LOG_DEBUG,
    "DEBUG: datalayer_persistance::persistentListData(tableId: %s)\n", 
    hash160ToString(tableId));
#endif
  /* TODO: dump a file appended with null localstoreunit pointer*/
  return &empty_units;
}

DHT_TableDef ** persistentListTables() {
#if DEBUG_DHT_DATALAYER
  LOG(LOG_DEBUG,"DEBUG: datalayer_persistance::persistentListTables()\n");
#endif
  /* TODO: dump list of files appended with null tabledef pointer*/
  return &empty_tables;
}

int persistentDeleteTable(
      const DHT_TableId * tableId) 
{
#if DEBUG_DHT_DATALAYER
  LOG(LOG_DEBUG,
    "DEBUG: datalayer_persistance::persistentDeleteTable(tableId: %s)\n", 
    hash160ToString(tableId));
#endif
  /* TODO: delete a file */
  return OK;
}
