
/* [BUG] Insert the GNU copyright here! */

/* dht-leave.c */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <gnunet_util.h>
#include "../include/dht_api.h"

static void printHelp()
{
  printf("USAGE: dht-leave [OPTIONS] "
	 "TABLE\n");
  printHelpDefault();
}

static int parseOptions(int argc,
			char ** argv)
{
  int c;  

  while (1) {
    int option_index = 0;
    static struct GNoption long_options[] = {
      LONG_DEFAULT_OPTIONS,
      { 0,0,0,0 }
    };
    c = GNgetopt_long(argc,
		      argv,
		      "vh" "H:c:L:d",
		      long_options, 
		      &option_index);    
    if (c == -1) 
      break;  /* No more flags to process */
    if (YES == parseDefaultOptions(c, GNoptarg))
      continue;
    switch(c) {
    case 'v': 
      printf("dht-leave: %s\n", "$Id: dht-leave.c,v 1.4 2004/05/20 11:32:33 tmtoivon Exp $");
      return SYSERR;
    case 'h': 
      printHelp(); 
      return SYSERR;
    default:
      LOG(LOG_FAILURE,
	  "Unknown option %c. Aborting.\n"
	  "Use --help to get a list of options.\n",
	  c);
      return SYSERR;
    } /* end of parsing commandline */
  } /* while (1) */
  if (argc - GNoptind != 1) {
    LOG(LOG_WARNING, 
	"Not enough arguments. "
	"You must specify at least a node and a table\n");
    printHelp();
    return SYSERR;
  }
  FREENONNULL(setConfigurationString("DHT-LEAVE",
				     "TABLE",
				     argv[GNoptind++]));
  return OK;
}

int main(int argc, char **argv)
{
  int errorCode; 

  DHT_TableHandle handle;
  HexName input;

  /* -- parse command line parameters -- */

  if (SYSERR == initUtil(argc, argv, &parseOptions)) {
    return EXIT_FAILURE; /* parse error, --help, etc. */
  }

  /* -- leave table -- */

  strncpy(input.data, getConfigurationString("DHT-LEAVE", "TABLE"), 41);
  hex2hash(&input, &handle.tableId);
  handle.errorCode = 1;
  errorCode = initializeApi();
  if (isError(errorCode)) {
    printf("Error in dht initialize api: %d\n",errorCode);
    return errorCode;
  } else {
    errorCode = leave(&handle);
    if(isError(errorCode)) {
      printf("leaving table (id: %s) returned an error (%d)\n",
         input.data, errorCode
      );
    } else {
      printf("succesfully left table (id: %s)\n",input.data);
    }
  }
  return 1; 
}
